#!/bin/csh -f 

# ilookup.sh modifies the colors of an image using the colors in another image.
# ilookup.sh horizontal_line lookup_image in_image out_image
# 	horizontal_line	the line in the lookup image to use to create the table
#	lookup_image	the image to use as a lookup table
#	in_image	the image to be modified, stdin in ice
#	out_image	the resulting output image, stdout in ice
# typical usage in ice:
# ilookup.sh `linear()` Rainbow.pic stdin stdout

   onintr cleanup

   set tmplookup=/usr/tmp/tmplookup$$.chan

# convert the ramp into a 4x256 array (lookup table) of RGBA values


   if ( $?OS ) then
       if ( $OS == "Windows_NT" ) then
	    set ibindir=$HFS/bin
       else
	    set ibindir=$HH/sbin
       endif
   else
       set ibindir=$HH/sbin
   endif

   $ibindir/itable $argv[1] $HH/pic/$argv[2] > $tmplookup

   ilookup -A $tmplookup $argv[3] $argv[4]


# clean up tmp files

cleanup:
   rm -f $tmplookup

