# 123.cmd : Houdini Master startup script
#
# This file gets sourced whenever Houdini Master starts up
#

# Create some useful aliases

# Variables set with the set command are local to this script only.
# Therefore, we don't have to worry about cleaning up.
# These variables are used to set the Function Key aliases below.
set F1 = desk set Animate
set F2 = desk set Build
set F3 = desk set Textport
set F4 = desk set CHOPs
set F5 = desk set Image
set F6 = desk set Particles
set F7 = desk set Model
set F8 = desk set VEX_Builder

# Set the function key aliases.
for i = 1 to 8
    alias F${i} ${F$i}
    alias AF${i} ${F$i}
end

alias cd	opcf
alias h		history
alias ls	opls
alias pwd	oppwf
alias rm	oprm
alias cp	opcp

alias SF10 'quit'


#
# Turn off aliases for the rest of this file in case of conflicts
#
set noalias = 1


#
# Set up the default scene when Houdini starts up
#
source defaultscene.cmd

#
#  UI control commands
#

# Set the prompt to display the current directory followed by an arrow
prompt '`strcat(oppwf(), " -> ")`'

# First we try to find a good desk to be the startup desk. If you want a
# different desk to be the default, just change the logic below (it gives
# the Build desk the highest priority, followed by the Animate desk).

set desks = `run("desk list")`
set build = 0
set animate = 0
foreach desk ( $desks )
    if ($desk == "Build")
	set build = 1
    else if ($desk == "Animate")
	set animate = 1
    endif
end

if ($build == 1) then
    desk set Build
else if ($animate == 1) then
    desk set Animate
endif

