#
#  Script used with Alfred output driver to render images from a RenderMan
#  output driver.
#
#  Command to generate an alfred task for a particular frame using renderman.
#  The arguments to the script are:
#
#	alf_rman.cmd driver
#
#  Where driver is the renderman driver to generate RIB.  This script is called
#  on an as needed basis.  i.e. when Alfred is ready for a frame, it will call
#  this script.
#

set driver = $arg1
opcf /out

if ( "$ALF_TMP" == "" ) then
    setenv ALF_TMP = /tmp
endif

set hipbase = `system("/bin/basename $HIPNAME")`
set tmpfile = $ALF_TMP/$hipbase.$driver$FF.rib

opparm $driver tscript ( on ) script ( $tmpfile )
opparm $driver trange ( off )

render $driver

echo "##AlfredToDo 2.0"
echo -n "Task { $driver Frame $F } "
echo -n "-cmds { "
echo -n   "Cmd { netrender -f -Progress %H $tmpfile } "
echo -n   "-service {pixarNRM|nrmserver} "
echo -n   "-tags {prman} "
echo -n "} "
echo -n "-cleanup { Cmd { rm $tmpfile } } "
echo
