#
#  This is used by the Make Bump Map COP Macro to create a bump map
#

if ( "$argc" != 3 ) then
    echo Usage:  source $arg0 disk_file blur_factor
else
    set cop_file = `execute("opadd -v file")`
    opparm $cop_file source ( "$arg1" )
    if ( $arg2 > 0 ) then
	set cop_blur = `execute("opadd -v blur")`
	opparm $cop_blur blur ( "$arg2" )
    else
	set cop_blur = ""
    endif

    set cop_bump = `execute("opadd -v bump")`

    oplocate -x 1 -y 1 $cop_file
    if ( "$cop_blur" != "" ) then
	opwire $cop_file -0 $cop_blur
	opwire $cop_blur -0 $cop_bump
	oplocate -x 2.5 -y 1 $cop_blur
	oplocate -x 4   -y 1 $cop_bump
	oplocate *
    else
	opwire $cop_file -0 $cop_bump
	oplocate -x 2.5 -y 1 $cop_bump
    endif
endif
