# Default script run when a force object is created
# $arg1 is the name of the object to create

\set noalias = 1
if ( "$arg1" != "" ) then
    opcf $arg1

    # Node fantubeangle
    opadd -n tube fantubeangle
    oplocate -x 3.43182 -y 3.74791 fantubeangle
    chadd -f 1 300 fantubeangle tz
    chkey -f 1 -v 0.5 -m 0 -a 1 -F '-ch("height")/2' fantubeangle/tz
    chadd -f 1 300 fantubeangle rad2
    chkey -f 1 -v 1 -m 0 -a 1 -F 'sin(ch("../fanangle")/2)' fantubeangle/rad2
    chadd -f 1 300 fantubeangle height
    chkey -f 1 -v 1 -m 0 -a 1 -F 'cos(ch("../fanangle")/2)' fantubeangle/height
    opparm fantubeangle orient ( z ) t ( 0 0 tz ) rad ( 0 rad2 ) height ( height )

    # Node fantubedelta
    opadd -n tube fantubedelta
    oplocate -x 4.75623 -y 3.75183 fantubedelta
    chadd -f 1 300 fantubedelta tz
    chkey -f 1 -v 0.5 -m 0 -a 1 -F '-ch("height")/2' fantubedelta/tz
    chadd -f 1 300 fantubedelta rad2
    chkey -f 1 -v 1 -m 0 -a 1 -F 'sin((ch("../fanangle") + ch("../fandelta"))/2)' fantubedelta/rad2
    chadd -f 1 300 fantubedelta height
    chkey -f 1 -v 1 -m 0 -a 1 -F 'cos((ch("../fanangle") + ch("../fandelta"))/2)' fantubedelta/height
    opparm fantubedelta orient ( z ) rad ( 0 rad2 )

    # Node forcetype
    opadd -n switch forcetype
    oplocate -x 3.46243 -y 1.6793 forcetype
    chadd -f 1 300 forcetype input
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("../forcetype")' forcetype/input
    opparm forcetype input ( input )

    # Node forcetube1
    opadd -n tube forcetube1
    oplocate -x 0.873884 -y 3.75801 forcetube1
    opparm forcetube1 orient ( z ) t ( 0 0 -0.375 ) rad ( 0.05 0.05 ) height ( 0.75 ) cap ( on )

    # Node forcetube2
    opadd -n tube forcetube2
    oplocate -x 2.1582 -y 3.74821 forcetube2
    opparm forcetube2 orient ( z ) t ( 0 0 -0.875 ) rad ( 0.1 0 ) height ( 0.25 ) cap ( on )

    # Node forcemerge
    opadd -n merge forcemerge
    oplocate -x 2.1386 -y 2.6894 forcemerge

    # Node fanmerge
    opadd -n merge fanmerge
    oplocate -x 3.46122 -y 2.6891 fanmerge

    # Node color
    opadd -n primitive color
    oplocate -x 3.46243 -y 0.679299 color
    chadd -f 1 300 color diffb
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("../dcolorb")' color/diffb
    chadd -f 1 300 color diffg
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("../dcolorg")' color/diffg
    chadd -f 1 300 color diffr
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("../dcolorr")' color/diffr
    opparm color doclr ( on ) diff ( diffr diffg diffb )

    # Node constriaintsubnet
    opadd -n subnet constriaintsubnet
    oplocate -x 4.78282 -y 2.69697 constriaintsubnet
    opcf constriaintsubnet

    # Node spherenail
    opadd -n sphere spherenail
    oplocate -x 0.045881 -y 5.04579 spherenail
    chadd -f 1 300 spherenail tz
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../nailptx"),ch("../../nailpty"),ch("../../nailptz")) * invert(optransform("../..")))[2]' spherenail/tz
    chadd -f 1 300 spherenail ty
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../nailptx"),ch("../../nailpty"),ch("../../nailptz")) * invert(optransform("../..")))[1]' spherenail/ty
    chadd -f 1 300 spherenail tx
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../nailptx"),ch("../../nailpty"),ch("../../nailptz")) * invert(optransform("../..")))[0]' spherenail/tx
    opparm spherenail rad ( 0.1 0.1 0.1 ) t ( tx ty tz )

    # Node mergenailspheres
    opadd -n merge mergenailspheres
    oplocate -x 1.68224 -y 3.69951 mergenailspheres

    # Node addnailconnector
    opadd -n add addnailconnector
    oplocate -x 1.68224 -y 2.43721 addnailconnector
    opparm addnailconnector stdswitcher ( 1 1 ) switcher ( 1 1 )

    # Node mergepointspheres
    opadd -n merge mergepointspheres
    oplocate -x 4.95264 -y 3.66933 mergepointspheres

    # Node addpointconnector
    opadd -n add addpointconnector
    oplocate -x 4.95264 -y 2.40703 addpointconnector
    opparm addpointconnector stdswitcher ( 1 1 ) switcher ( 1 1 )

    # Node switchconstrainttype
    opadd -n switch switchconstrainttype
    oplocate -x 4.93477 -y 1.13135 switchconstrainttype
    chadd -f 1 300 switchconstrainttype input
    chkey -f 1 -v 0 -m 0 -a 1 -F 'ch("../../constrainttype")' switchconstrainttype/input
    opparm switchconstrainttype input ( input )

    # Node sphereobj
    opadd -n sphere sphereobj
    oplocate -x 1.70127 -y 5.03582 sphereobj
    chadd -f 1 300 sphereobj tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../nailobjx"),ch("../../nailobjy"),ch("../../nailobjz")), TZ)' sphereobj/tz
    chadd -f 1 300 sphereobj ty
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../nailobjx"),ch("../../nailobjy"),ch("../../nailobjz")), TY)' sphereobj/ty
    chadd -f 1 300 sphereobj tx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0),chs("../../obja"), vector3(ch("../../nailobjx"),ch("../../nailobjy"),ch("../../nailobjz")), TX)' sphereobj/tx
    opparm sphereobj rad ( 0.1 0.1 0.1 ) t ( tx ty tz )

    # Node sphereobja
    opadd -n sphere sphereobja
    oplocate -x 4.93245 -y 5.03568 sphereobja
    chadd -f 1 300 sphereobja tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../ptobjax"),ch("../../ptobjay"),ch("../../ptobjaz")), TZ)' sphereobja/tz
    chadd -f 1 300 sphereobja ty
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../ptobjax"),ch("../../ptobjay"),ch("../../ptobjaz")), TY)' sphereobja/ty
    chadd -f 1 300 sphereobja tx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0),chs("../../obja"), vector3(ch("../../ptobjax"),ch("../../ptobjay"),ch("../../ptobjaz")), TX)' sphereobja/tx
    opparm sphereobja rad ( 0.1 0.1 0.1 ) t ( tx ty tz )

    # Node sphereobjb
    opadd -n sphere sphereobjb
    oplocate -x 6.58784 -y 5.03582 sphereobjb
    chadd -f 1 300 sphereobjb tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../objb"), vector3(ch("../../ptobjbx"),ch("../../ptobjby"),ch("../../ptobjbz")), TZ)' sphereobjb/tz
    chadd -f 1 300 sphereobjb ty
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../objb"), vector3(ch("../../ptobjbx"),ch("../../ptobjby"),ch("../../ptobjbz")), TY)' sphereobjb/ty
    chadd -f 1 300 sphereobjb tx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0),chs("../../objb"), vector3(ch("../../ptobjbx"),ch("../../ptobjby"),ch("../../ptobjbz")), TX)' sphereobjb/tx
    opparm sphereobjb rad ( 0.1 0.1 0.1 ) t ( tx ty tz )

    # Node rotvec
    opadd -n add rotvec
    oplocate -x 8.2421 -y 4.98522 rotvec
    chadd -f 1 300 rotvec pt3z
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../rotobjx"), ch("../../rotobjy"), ch("../../rotobjz")), TZ)' rotvec/pt3z
    chadd -f 1 300 rotvec pt3y
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../rotobjx"), ch("../../rotobjy"), ch("../../rotobjz")), TY)' rotvec/pt3y
    chadd -f 1 300 rotvec pt3x
    chkey -f 1 -v 0 -m 0 -a 1 -F 'originoffset("../..", vector3(0,0,0), chs("../../obja"), vector3(ch("../../rotobjx"), ch("../../rotobjy"), ch("../../rotobjz")), TX)' rotvec/pt3x
    chadd -f 1 300 rotvec pt2z
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TZ)' rotvec/pt2z
    chadd -f 1 300 rotvec pt2y
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TY)' rotvec/pt2y
    chadd -f 1 300 rotvec pt2x
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TX)' rotvec/pt2x
    chadd -f 1 300 rotvec pt1z
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../rotvecx"),ch("../../rotvecy"),ch("../../rotvecz")) * invert(optransform("../..")))[2]' rotvec/pt1z
    chadd -f 1 300 rotvec pt1y
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../rotvecx"),ch("../../rotvecy"),ch("../../rotvecz")) * invert(optransform("../..")))[1]' rotvec/pt1y
    chadd -f 1 300 rotvec pt1x
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(ch("../../rotvecx"),ch("../../rotvecy"),ch("../../rotvecz")) * invert(optransform("../..")))[0]' rotvec/pt1x
    chadd -f 1 300 rotvec pt0z
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(0,0,0) * invert(optransform("../..")))[2]' rotvec/pt0z
    chadd -f 1 300 rotvec pt0y
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(0,0,0) * invert(optransform("../..")))[1]' rotvec/pt0y
    chadd -f 1 300 rotvec pt0x
    chkey -f 1 -v 0 -m 0 -a 1 -F '(vector3(0,0,0) * invert(optransform("../..")))[0]' rotvec/pt0x
    opparm rotvec stdswitcher ( 1 1 ) points 4 usept0 ( on ) pt0 ( pt0x pt0y pt0z ) usept1 ( on ) pt1 ( pt1x pt1y pt1z ) usept2 ( on ) pt2 ( pt2x pt2y pt2z ) usept3 ( on ) pt3 ( pt3x pt3y pt3z ) prims 3 prim0 ( '0 1' ) prim1 ( '2 3' ) prim2 ( '0 2' )

    # Node vecshaft
    opadd -n wire vecshaft
    oplocate -x 8.2421 -y 3.71316 vecshaft
    chadd -f 1 300 vecshaft radius
    chkey -f 1 -v 0.05 -m 0 -a 1 -F 'ch("../vechead/height") / 6' vecshaft/radius
    opparm vecshaft group ( '0 1' ) radius ( radius ) corners ( off ) caps ( on )

    # Node vechead
    opadd -n tube vechead
    oplocate -x 9.87729 -y 4.96876 vechead
    chadd -f 1 300 vechead rad2
    chkey -f 1 -v 0.1 -m 0 -a 1 -F 'ch("height") / 3' vechead/rad2
    chadd -f 1 300 vechead height
    chkey -f 1 -v 0.2 -m 0 -a 1 -F 'length(point("../addN", 1, "N", 0),point("../addN", 1, "N", 1),point("../addN", 1, "N", 2)) / 5' vechead/height
    chadd -f 1 300 vechead tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'ch("height") / 2' vechead/tz
    opparm vechead orient ( z ) t ( 0 0 tz ) rad ( 0 rad2 ) height ( height ) cap ( on )

    # Node mergerotvec
    opadd -n merge mergerotvec
    oplocate -x 8.26231 -y 2.44757 mergerotvec

    # Node movevechead
    opadd -n copy movevechead
    oplocate -x 9.88739 -y 3.72339 movevechead
    opparm movevechead templateGrp ( '1 3' )

    # Node addN
    opadd -n point addN
    oplocate -x 11.5125 -y 4.96887 addN
    chadd -f 1 300 addN nz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'point("../rotvec", $PT, "P", 2) - point("../rotvec", $PT-1, "P", 2)' addN/nz
    chadd -f 1 300 addN ny
    chkey -f 1 -v 0 -m 0 -a 1 -F 'point("../rotvec", $PT, "P", 1) - point("../rotvec", $PT-1, "P", 1)' addN/ny
    chadd -f 1 300 addN nx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'point("../rotvec", $PT, "P", 0) - point("../rotvec", $PT-1, "P", 0)' addN/nx
    opparm addN donml ( on ) n ( nx ny nz )

    # Node sphereobjaorg
    opadd -n sphere sphereobjaorg
    oplocate -x 3.36679 -y 5.02582 sphereobjaorg
    chadd -f 1 300 sphereobjaorg tx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TX)' sphereobjaorg/tx
    chadd -f 1 300 sphereobjaorg ty
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TY)' sphereobjaorg/ty
    chadd -f 1 300 sphereobjaorg tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../obja"), TZ)' sphereobjaorg/tz
    opparm sphereobjaorg rad ( 0.05 0.05 0.05 ) t ( tx ty tz )

    # Node sphereobjborg
    opadd -n sphere sphereobjborg
    oplocate -x 6.58669 -y 3.71268 sphereobjborg
    chadd -f 1 300 sphereobjborg tx
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../objb"), TX)' sphereobjborg/tx
    chadd -f 1 300 sphereobjborg ty
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../objb"), TY)' sphereobjborg/ty
    chadd -f 1 300 sphereobjborg tz
    chkey -f 1 -v 0 -m 0 -a 1 -F 'origin("../..", chs("../../objb"), TZ)' sphereobjborg/tz
    opparm sphereobjborg rad ( 0.05 0.05 0.05 ) t ( tx ty tz )

    opcf ..
    opwire forcemerge -0 forcetype
    opwire fanmerge -1 forcetype
    opwire constriaintsubnet -2 forcetype
    opwire forcetube1 -0 forcemerge
    opwire forcetube2 -1 forcemerge
    opwire fantubeangle -0 fanmerge
    opwire fantubedelta -1 fanmerge
    opwire forcetype -0 color
    opcf constriaintsubnet
    opwire spherenail -0 mergenailspheres
    opwire sphereobj -1 mergenailspheres
    opwire sphereobjaorg -2 mergenailspheres
    opwire mergenailspheres -0 addnailconnector
    opwire sphereobjaorg -0 mergepointspheres
    opwire sphereobja -1 mergepointspheres
    opwire sphereobjb -2 mergepointspheres
    opwire sphereobjborg -3 mergepointspheres
    opwire mergepointspheres -0 addpointconnector
    opwire addnailconnector -0 switchconstrainttype
    opwire addpointconnector -1 switchconstrainttype
    opwire mergerotvec -2 switchconstrainttype
    opwire rotvec -0 vecshaft
    opwire vecshaft -0 mergerotvec
    opwire movevechead -1 mergerotvec
    opwire vechead -0 movevechead
    opwire addN -1 movevechead
    opwire rotvec -0 addN
    opset -d on -r on switchconstrainttype
    opcf ..
    opset -d on -r on color
    
    opcf ..
    chadd -f 1 300 $arg1 sy
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("sz")' $arg1/sy
    chadd -f 1 300 $arg1 sx
    chkey -f 1 -v 1 -m 0 -a 1 -F 'ch("sz")' $arg1/sx
    opparm $arg1 t ( 0 2 0 ) r ( -90 0 0 ) rotvec ( 0 0 1 ) rotobj ( 0 0 1 ) dcolor ( 0.332478 0.846 0.409506 )
    opset -d on -r off -t off -l off -s off -u off $arg1
endif
