# Default script run when a sound object is created.
# $arg1 is the name of the object to create

\set noalias = 1
if ( "$arg1" != "" ) then
    opparm $arg1 dcolor( 0 0.75 0 )
    opcf $arg1

    # Node tube1
    opadd -n tube tube1
    oplocate -x 3 -y 2.5 tube1
    chadd -t 0 9.96667 tube1 height
    chkey -t 0 -v 0.5 -m 0 -a 1 -F 'if(ch("../add2/pt0x")<45 || ch("../add2/pt0x")>135, if(ch("../add2/pt0x")>135,-0.5,0.5), 0.5*cos(ch("../add2/pt0x"))/sin(ch("../add2/pt0x")))' tube1/height
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube1/height
    chadd -t 0 9.96667 tube1 rad2
    chkey -t 0 -v 1 -m 0 -a 1 -F '0.11+0.5*if(ch("../add2/pt0x")>45 && ch("../add2/pt0x")<135,1,abs(tan(ch("../add2/pt0x"))))' tube1/rad2
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube1/rad2
    chadd -t 0 9.96667 tube1 tz
    chkey -t 0 -v 0 -m 0 -a 1 -F '-ch("height")*.5' tube1/tz
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube1/tz
    opparm tube1 stdswitcher ( 0 0 ) type ( prim ) surftype ( quads ) orient ( z ) t ( 0 0 tz ) rad ( 0.11 rad2 ) height ( height ) imperfect ( on ) rows ( 2 ) cols ( 10 ) orderu ( 4 ) orderv ( 2 ) cap ( off )
    opset -d off -r off -t off -l off -s off -u off -c off -C off -p off -e on -b off tube1

    # Node add1
    opadd -n add add1
    oplocate -x 2.25 -y 0 add1
    opparm add1 stdswitcher ( 0 0 )
    opset -d off -r on -t off -l off -s off -u off -c off -C off -p off -e on -b off add1

    # Node add2
    opadd -n add add2
    oplocate -x 4.5 -y 2.5 add2
    chadd -t 0 9.96667 add2 pt0z
    chkey -t 0 -v 0 -m 0 -a 1 -F 'cubic()' add2/pt0z
    chkey -t 9.96667 -v 0 -m 0 -a 1 add2/pt0z
    chadd -t 0 9.96667 add2 pt0y
    chkey -t 0 -v 0 -m 0 -a 1 -F 'if(ch("../emitcone")+ch("../outcone")>180,180,ch("../emitcone")+ch("../outcone"))' add2/pt0y
    chkey -t 9.96667 -v 0 -m 0 -a 1 add2/pt0y
    chadd -t 0 9.96667 add2 pt0x
    chkey -t 0 -v 0 -m 0 -a 1 -F 'if(ch("../emitcone")>180,180,ch("../emitcone"))' add2/pt0x
    chkey -t 9.96667 -v 0 -m 0 -a 1 add2/pt0x
    opparm add2 stdswitcher ( 0 0 ) usept0 ( on ) pt0 ( pt0x pt0y pt0z ) weight0 ( 1 )
    opset -d off -r off -t off -l off -s off -u off -c off -C off -p off -e on -b off add2

    # Node tube2
    opadd -n tube tube2
    oplocate -x 1.5 -y 2.5 tube2
    chadd -t 0 9.96667 tube2 height
    chkey -t 0 -v 0.5 -m 0 -a 1 -F 'if(ch("../add2/pt0y")<45 || ch("../add2/pt0y")>135, if(ch("../add2/pt0y")>135,-0.3,0.3), 0.3*cos(ch("../add2/pt0y"))/sin(ch("../add2/pt0y")))' tube2/height
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube2/height
    chadd -t 0 9.96667 tube2 rad2
    chkey -t 0 -v 1 -m 0 -a 1 -F '0.11+0.3*if(ch("../add2/pt0y")>45 && ch("../add2/pt0y")<135,1,abs(tan(ch("../add2/pt0y"))))' tube2/rad2
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube2/rad2
    chadd -t 0 9.96667 tube2 tz
    chkey -t 0 -v 0 -m 0 -a 1 -F '-ch("height")*.5' tube2/tz
    chkey -t 9.96667 -v 0.5 -m 0 -a 1 tube2/tz
    opparm tube2 stdswitcher ( 0 0 ) type ( prim ) surftype ( quads ) orient ( z ) t ( 0 0 tz ) rad ( 0.11 rad2 ) height ( height ) imperfect ( on ) rows ( 2 ) cols ( 10 ) orderu ( 4 ) orderv ( 2 ) cap ( off )
    opset -d off -r off -t off -l off -s off -u off -c off -C off -p off -e on -b off tube2

    # Node merge2
    opadd -n merge merge2
    oplocate -x 2.25 -y 1 merge2
    opparm merge2
    opset -d on -r off -t off -l off -s off -u off -c off -C off -p off -e on -b off merge2
    opwire file1 -0 merge2
    opwire tube2 -1 merge2
    opwire tube1 -2 merge2
    opwire add2  -3 merge2

    # Node file1
    opadd -n file file1
    oplocate -x 0 -y 2.5 file1
    opparm file1 file ( soundbase.bgeo )
    opset -d off -r off -t off -l off -s off -u off -c off -C on -p off -e on -b off file1
    opcf ..
endif
