/*
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Side Effects Software Inc., and is not to be reproduced,
 * transmitted, or disclosed in any way without written permission.
 *
 * Produced by:
 *	Side Effects Software Inc
 *	477 Richmond Street West
 *	Toronto, Ontario
 *	Canada   M5V 3E7
 *	416-504-9876
 *
 * NAME:	FS_HomeHelper.h ( OTL Library, C++)
 *
 * COMMENTS:
 *
 */

#ifndef __FS_HomeHelper__
#define __FS_HomeHelper__

#include <FS/FS_Reader.h>
#include <FS/FS_Writer.h>
#include <FS/FS_Info.h>
#include <FS/FS_Utils.h>

class FS_HomeReadHelper : public FS_ReaderHelper
{
public:
	     FS_HomeReadHelper();
    virtual ~FS_HomeReadHelper();

    virtual FS_ReaderStream	*createStream(const char *source);
};

class FS_HomeWriteHelper : public FS_WriterHelper
{
public:
	     FS_HomeWriteHelper();
    virtual ~FS_HomeWriteHelper();

    virtual FS_WriterStream	*createStream(const char *source);
};

class FS_HomeInfoHelper : public FS_InfoHelper
{
public:
	     FS_HomeInfoHelper();
    virtual ~FS_HomeInfoHelper();

    virtual bool	 canHandle(const char *source);
    virtual bool	 hasAccess(const char *source, int mode);
    virtual bool	 getIsDirectory(const char *source);
    virtual int		 getModTime(const char *source);
    virtual bool	 getContents(const char *source,
				     UT_StringArray &contents,
				     UT_StringArray *dirs);
};

#endif

