/*
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Side Effects Software Inc., and is not to be reproduced,
 * transmitted, or disclosed in any way without written permission.
 *
 * Produced by:
 *      Side Effects
 *      477 Richmond Street West
 *      Toronto, Ontario
 *      Canada   M5V 3E7
 *      416-504-9876
 *
 * NAME:	SOP library (C++)
 *
 * COMMENTS:	BlindData SOP.  This example shows how to save private data to
 *		a HIP file.
 */


#ifndef __SOP_BlindData_h__
#define __SOP_BlindData_h__

#include <SOP/SOP_Node.h>

class SOP_BlindData : public SOP_Node
{
public:
	     SOP_BlindData(OP_Network *net, const char *name, OP_Operator *op);
    virtual ~SOP_BlindData();

    static PRM_Template		 myTemplateList[];
    static OP_Node		*myConstructor(OP_Network*, const char *,
							    OP_Operator *);

protected:
    virtual const char          *inputLabel(unsigned idx) const;
    virtual OP_ERROR		 cookMySop(OP_Context &context);

    virtual OP_ERROR		 save(ostream &os, const OP_SaveFlags &flags,
				      const char *path_prefix);
    virtual OP_ERROR		 load(istream &is,
					int binary,
					const char *extension,
					int filesize,
					const char *path);
private:

    int			loadPrivateData(istream &is, int binary);
    int			savePrivateData(ostream &os, int binary);
};

#endif
